#ifndef CMODEL_H
#define CMODEL_H

#include "vector.h"
#include "chain.h"
#include "geometry.h"

#define CMODEL_FIRST

class CModel : public Chain {
public:
	CModel() {Reset();}
	~CModel() {Unload();}

	bool Load(char *filename);
	void Unload(void);
	void Reset(void);

	friend CModel *GetCModel(Chain *p, char *title);

	char	title[64];

	int		vtxCount;
	Vector	*vtx;		//vtxCount

#ifdef CMODEL_FIRST
	int		planeCount;
	Plane	*plane;		//triCount

	int		edgeCount;
	int		*edge;		//2*edgeCount
#else
	int		triCount;
	int		*tri;		//3*triCount
	Vector	*triNormal;	//triCount
#endif

	Box		bbox;
	float	radius;	//stealing Quake1 ideas... maximum magnitude vertex distance - ONLY USED FOR DEBUG NORMAL DISPLAY!!!
};

#endif

//second system involves triangle array / triangle normal array / no edge array