#ifndef ENGINE_H
#define ENGINE_H

//#include <windows.h>	//for HMENU - for the editor

#include "camera.h"
#include "entity.h"
#include "mirror.h"
#include "world.h"
#include "particle.h"
#include "skyrender.h"

//TODO: move Time somewhere else - main object

class M_Engine {
public:
	// *********** CREATION *********** 
	M_Engine();
	bool Init();

	// *********** DESTRUCTION *********** 
	~M_Engine();
	void Kill();

	// *********** UPDATE *********** 
	void Update();
private:
	void GetKbdInput();
	//display
	void Display_Mirrors();
	void Display_Scene();

	//important stuff
	M_World				*world;
	M_SkyRender			*skyRender;

	//display reasons
	M_Mirror		*mirror;
	int				mirrorCount;

	// *********** CAMERA *********** 

#define ENGINE_CAMERA_MAX 16
public:
	void SetCamera(M_Camera *);
	void SetCamera(int );
	M_Camera *GetCamera(int );
	int GetCurrentCameraID(void);
private:
	M_Camera engine_camera[ENGINE_CAMERA_MAX];
	M_Camera *camera;	//the currently-selected camera

	// *********** MAP OBJECTS ***********
public:
	ParticleSystem	*particleSystem;
	Chain cmodelChain;
	Chain modelChain;
	Chain skinChain;

	// *********** EDITOR *********** 
	//toggling
public:
	void ToggleEditor(void);
private:
	void EnterEditor(void);
	void ExitEditor(void);

	//interface keyboard input
private:
	void Editor_GetKbdInput(void);
public:
	friend void Engine_Editor_MenuCmd(int cmd, void *param);

	//map variables
private:
	int		InEditor;
	float	Editor_Camera_Speed;
	float	Editor_Camera_Rot;

	//menu variables
//	HMENU	mainMenu;
//	HMENU	fileMenu;

public:
	static double Time;
};

#endif