#include <windows.h>	//for inclusion of memcpy and memset

#include "keyboard.h"
#include "console.h"
#include "main.h"

M_KeyboardHandler::M_KeyboardHandler()
{
	Reset();
}

void M_KeyboardHandler::Reset(void)
{
	memset(keypress, 0, sizeof(keypress));
	memset(keypress_last, 0, sizeof(keypress));
	memset(keystate, 0, sizeof(keystate));
}

void M_KeyboardHandler::KeyUp(int key)
{
	keypress[key] = 0;
}

void M_KeyboardHandler::KeyDown(int key)
{
	//if a main console exists, then only register the keypress if the main console doesnt grab it
	if (main_console)
	{
		if (!main_console->KeyDown(key)) keypress[key] = 1;
	}
	//else, grab it regardless of anything
	else
	{
		keypress[key] = 1;
	}
}

void M_KeyboardHandler::Update(void)
{
	// *************** INTRO - calc the keystat array via the keypress and keypress_last arrays

	for (int x = 0; x < KBH_KEY_COUNT; x++)
	{
		if (keypress[x])	//key down
		{
			if (keypress_last[x])		//it is pressed and has been presssed
				keystate[x] = KBH_DOWN;
			else					//is being pressed but has not been before
				keystate[x] = KBH_PRESS;
		}
		else			//key up
		{
			if (keypress_last[x])		//is being released and was being pressed
				keystate[x] = KBH_RELEASE;
			else					//is up and has been up
				keystate[x] = KBH_UP;
		}
	}

	// *************** ENCORE - copy the keypress map to the keypress_last map

	memcpy(keypress_last, keypress, sizeof(keypress));
}
