#ifndef KEYBOARD_H
#define KEYBOARD_H

#define KBH_KEY_COUNT	256

#define KBH_UP		0
#define KBH_DOWN	1
#define KBH_PRESS	2
#define KBH_RELEASE	3

//TODO make main_keyboard part of a main object which all other objects can access

class M_KeyboardHandler {
public:
	M_KeyboardHandler();

	//called upon init and before the window loses focus
	void Reset(void);

	//call when a key is pressed
	void KeyUp(int key);
	//call when a key is depressed
	void KeyDown(int key);

	//call to calculate the keystate array and copy the current keypress over the last
	void Update(void);

	//the state of a key - PRESSED, DOWN, DEPRESSED, UP
	char keystate[KBH_KEY_COUNT];

private:
	//whether a key is up or down (0 or 1, respectively)
	char keypress[KBH_KEY_COUNT];
	char keypress_last[KBH_KEY_COUNT];
};

#endif