#ifndef MODEL_H
#define MODEL_H

#include "vector.h"
#include "chain.h"
#include "geometry.h"
#include "types.h"

class Model : public Chain {
public:
	Model();
	~Model() {Unload();}

	bool Load(char *filename);
	void Unload(void);

	friend void DisplayModel(Model *m);
	friend Model *GetModel(Chain *p, char *title);


	char	title[64];

	int		triCount;
	int		*tri;		//3*triCount

	int			vtxCount;
	Vector		*vtx;		//vtxCount
	texcoord_t	*texCoord;	//vtxCount
	Vector		*normal;	//vtxCount

	Box		bbox;
	float	radius;	//stealing Quake1 ideas... maximum magnitude vertex distance - ONLY USED FOR DEBUG NORMAL DISPLAY!!!
};

#endif