#ifndef RENDER_H
#define RENDER_H

#include "types.h"

typedef struct {
	color_t		color;			//unsigned byte rgba
	texcoord_t	texcoord;		//signed short st
	float		normal[3];		//floating point xyz
	float		vertex[3];		//floating point xyz
} rvertex_t;

typedef struct {
	int			flags;
#define RF_TEXTURE		1		//glEnable(GL_TEXTURE_2D)
#define RF_CULLFACE		2		//glEnable(GL_CULL_FACE)
#define RF_BLENDFUNC	4		//glEnable(GL_BLEND)	/ glBlendFunc(blend_func.s, blend_func.t)
#define RF_SPHEREMAP	8		//glTexGenf(GL_S / GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
#define RF_MODULATE		16		//glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	int			texture;		//texture id
	texcoord_t	blend_func;		//st - src,dest blend function

	int			first_index;
	int			index_count;
	int			element_type;	//glDrawElements(element_type, index_count, GL_UNSIGNED_INT, &indexbuffer[first_index]);
} robj_t;

/*
so this allows special effects such as environment mapping
but how do we deal with multitexturing?
i know - create two objects which use the same vertex array data
		but contain different texture / blend functions...
		right?

how should we construct the renderer to allow passing of multiple objects attached to the same verticies?
should we - pass objects with multiple layers

how should we z-sort the blended?
*/

#endif