#include <windows.h>
#include <gl/gl.h>

#include "skyrender.h"
#include "const.h"		//M_PI def

#include "vector.h"
#include "quat.h"

#include "console.h"
#include "random.h"	//temp?

#include "main.h"		//main_console

M_SkyRender::M_SkyRender() {
	background[0] = NULL;
	background[1] = NULL;
};

bool M_SkyRender::Init(void)
{
	//load the textures - cloud
	background[0] = new Texture();
	if (background[0] &&  !background[0]->Create("WorldData/Background/bg1.bmp"))
	{
		delete background[0];
		background[0] = NULL;
	}
	if (!background[0]) return false;

	//and sun
	background[1] = new Texture();
	if (background[1] &&  !background[1]->Create("WorldData/Background/bg2.bmp"))
	{
		delete background[1];
		background[1] = NULL;
	}
	if (!background[1]) return false;

	return true;
}

void M_SkyRender::Kill(void)
{
	if (background[0]) delete background[0];
	background[0] = NULL;
	if (background[1]) delete background[1];
	background[1] = NULL;
};


void M_SkyRender::Display(void)
{
	//push the following attributes
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	glDisable(GL_DEPTH_TEST);	//disable depth testing			//GL_DEPTH_BUFFER_BIT

	glDisable(GL_FOG);			//disable fog					//GL_FOG_BIT

	glDisable(GL_CULL_FACE);	//disable backface culling		//GL_ENABLE_BIT

	//scale it far away enough that nothing gets near clipped
	glScalef(10,10,10);

static float bg_vtx[6][3] = {{0,0,1},{0,0,-1},{1,0,0},{-1,0,0},{0,1,0},{0,-1,0}};
static float bg_tex[6][2] = {{0.5f,0.5f},{0.5f,0.5f},{0,0},{1,1},{0,1},{1,0}};
static int bg_tri[8][3] = {{0,2,4},{0,4,3},{0,3,5},{0,5,2},{1,4,2},{1,3,4},{1,5,3},{1,2,5} };

	glColor3f(1,1,1);

	int a,b,c;
	for (c = 0; c < 2; c++)
	{
		SetTexture(background[c]);
		glBegin(GL_TRIANGLES);
		for (a = c*4; a < (c+1)*4; a++)
		{
			for (b = 0; b < 3; b++)
			{
				glTexCoord2fv(bg_tex[bg_tri[a][b]]);
				glVertex3fv(bg_vtx[bg_tri[a][b]]);
			}
		}
		glEnd();
	}

	glPopAttrib();
};