#ifndef TEXTURES_H
#define TEXTURES_H

#include "chain.h"

class Texture : public Chain {

public:
	friend Texture *GetTexture(Chain *p, char *title);

// ********** CONSTRUCTION/DESTRUCTION ********** 
public:
	Texture();					//zero all the vars
	void Destroy(void);
//unlink an Texture from the list
	~Texture() {Destroy();}

// ********** SETTING CURRENT TEXTURE ********** 

	friend void SetTexture(Texture *t);

// ********** TEXTURE PRE-CREATION ********** 
public:
	bool CreateEmpty(int bytes_per_pixel, int width, int height);
	void UpdateData(int bytes_per_pixel, int width, int height, void *src);

// ********** TEXTURE ARRAY EXTRACTION ********** 
public:
	bool Extract(unsigned char *ptr, int bytes_pp, int width, int height, int colskip, int rowskip);

// ********** TEXTURE IMAGE LOADING ********** 
public:
	bool Create(char *fn);		//load the texture - return the texture ID
	unsigned int texture_id;

private:
	char title[64];

	bool LoadData(char *fn);
	bool ConvertData(void);
	bool LoadBMP(char *filename);
	bool LoadTGA(char *filename);

	unsigned int width, height, bytes_per_pixel, flags;
	unsigned char *data;
};



#endif