#include <math.h>
#include "vector.h"

#include "const.h"
Vector vectorInf(fInf, fInf, fInf);
Vector base_axis[3] = {Vector(1,0,0), Vector(0,1,0), Vector(0,0,1)};

Vector::Vector()
{
	x = y = z = 0;
}

Vector::Vector(float vx, float vy, float vz)
{
	x = vx; y = vy; z = vz;
}

void Vector::LERP(Vector *start, Vector *end, float coeff)
{
/*
	Vector del(end);
	del.sub(start);
	del.scale(coeff);
	*this = *start;
	add(&del);
*/
	x = start->x * (1.f - coeff) + end->x * coeff;
	y = start->y * (1.f - coeff) + end->y * coeff;
	z = start->z * (1.f - coeff) + end->z * coeff;
}

float Vector::length(void) { return (float)sqrt(normal()); }

//calc the normal of the plane based upon the three vectors
//and store it in the current vector
void Vector::CalcNormal(Vector *v1, Vector *v2, Vector *v3)
{
	Vector del1, del2;

	del1.sub(v1, v2);
	del2.sub(v3, v2);

	cross(&del1, &del2);
	normalize();
}
