#ifndef DISPLAY_H
#define DISPLAY_H

#include "oglh.h"
#include "keyboard.h"

//used internally - via set keyboard handler
#define MY_WM_POST_OGLH		0x2501
#define MY_WM_POST_KBDH		0x2502
//used externally - by m_engine - upon entering/exiting editor state
#define MY_WM_POST_MENUFUNC	0x2503

class M_Display {
public:
	//construction
	M_Display();
	bool Init(void);	

	//destruction
	~M_Display();
	void Kill(void);

	//clear screen
	void Clear(void);
	//swap buffers
	void Update(void);

	//to grab the display window
	HWND GetHWnd(void) {return displayWnd; }

	void SetKeyboardHandler(M_KeyboardHandler *);

	int GetWidth(void);	//big hack - this grabs the OpenGL width
	int GetHeight(void);	//this grabs the OpenGL height

private:

	//the opengl handler
	OpenGLHandler oglh;

	//the display window - created upon Init, destroyed upon Kill
	HWND displayWnd;
};

#endif